diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/test/tx-duration-test.cc ns-3.43/src/wifi/test/tx-duration-test.cc
--- ns-3.42/src/wifi/test/tx-duration-test.cc	2024-05-29 15:29:47.216073800 -0700
+++ ns-3.43/src/wifi/test/tx-duration-test.cc	2024-10-09 16:41:10.136656800 -0700
@@ -1246,7 +1383,7 @@
                  std::list<HeMuUserInfo>{{{HeRu::RU_242_TONE, 1, true}, 0, 1},
                                          {{HeRu::RU_242_TONE, 2, true}, 0, 1}},
                  40,
-                 800,
+                 NanoSeconds(800),
                  WIFI_PREAMBLE_HE_MU,
                  NanoSeconds(
                      1493600)) // equivalent to HE_SU for 20 MHz with 2 extra HE-SIG-B (i.e. 8 us)
@@ -1254,14 +1391,14 @@
                                   std::list<HeMuUserInfo>{{{HeRu::RU_242_TONE, 1, true}, 1, 1},
                                                           {{HeRu::RU_242_TONE, 2, true}, 0, 1}},
                                   40,
-                                  800,
+                                  NanoSeconds(800),
                                   WIFI_PREAMBLE_HE_MU,
                                   NanoSeconds(1493600)) // shouldn't change if first PSDU is shorter
              && CheckMuTxDuration(std::list<uint32_t>{1536, 76},
                                   std::list<HeMuUserInfo>{{{HeRu::RU_242_TONE, 1, true}, 0, 1},
                                                           {{HeRu::RU_242_TONE, 2, true}, 0, 1}},
                                   40,
-                                  800,
+                                  NanoSeconds(800),
                                   WIFI_PREAMBLE_HE_MU,
                                   NanoSeconds(1493600));
 
@@ -1273,21 +1410,21 @@
                                std::list<HeMuUserInfo>{{{HeRu::RU_242_TONE, 1, true}, 0, 1},
                                                        {{HeRu::RU_242_TONE, 2, true}, 0, 1}},
                                40,
-                               800,
+                               NanoSeconds(800),
                                WIFI_PREAMBLE_EHT_MU,
                                NanoSeconds(1493600)) // equivalent to 802.11ax MU
              && CheckMuTxDuration(std::list<uint32_t>{1536, 1536},
                                   std::list<HeMuUserInfo>{{{HeRu::RU_242_TONE, 1, true}, 1, 1},
                                                           {{HeRu::RU_242_TONE, 2, true}, 0, 1}},
                                   40,
-                                  800,
+                                  NanoSeconds(800),
                                   WIFI_PREAMBLE_EHT_MU,
                                   NanoSeconds(1493600)) // shouldn't change if first PSDU is shorter
              && CheckMuTxDuration(std::list<uint32_t>{1536, 76},
                                   std::list<HeMuUserInfo>{{{HeRu::RU_242_TONE, 1, true}, 0, 1},
                                                           {{HeRu::RU_242_TONE, 2, true}, 0, 1}},
                                   40,
-                                  800,
+                                  NanoSeconds(800),
                                   WIFI_PREAMBLE_EHT_MU,
                                   NanoSeconds(1493600));
 
@@ -1319,7 +1456,7 @@
      *
      * \param userInfos the HE MU specific per-user information to use for the test
      * \param sigBMode the mode to transmit HE-SIG-B for the test
-     * \param channelWidth the channel width in MHz to select for the test
+     * \param channelWidth the channel width to select for the test
      * \param expectedMuType the expected MU type (OFDMA or MU-MIMO)
      * \param expectedRuAllocation the expected RU_ALLOCATION
      * \param expectedNumUsersPerCc the expected number of users per content channel
@@ -1327,7 +1464,7 @@
      */
     HeSigBDurationTest(const std::list<HeMuUserInfo>& userInfos,
                        const WifiMode& sigBMode,
-                       uint16_t channelWidth,
+                       MHz_u channelWidth,
                        MuType expectedMuType,
                        const RuAllocation& expectedRuAllocation,
                        const std::pair<std::size_t, std::size_t>& expectedNumUsersPerCc,
@@ -1345,7 +1482,7 @@
 
     std::list<HeMuUserInfo> m_userInfos; ///< HE MU specific per-user information
     WifiMode m_sigBMode;                 ///< Mode used to transmit HE-SIG-B
-    uint16_t m_channelWidth;             ///< Channel width in MHz
+    MHz_u m_channelWidth;                ///< Channel width
     MuType m_expectedMuType;             ///< Expected MU type (OFDMA or MU-MIMO)
     RuAllocation m_expectedRuAllocation; ///< Expected RU_ALLOCATION
     std::pair<std::size_t, std::size_t>
@@ -1356,7 +1493,7 @@
 HeSigBDurationTest::HeSigBDurationTest(
     const std::list<HeMuUserInfo>& userInfos,
     const WifiMode& sigBMode,
-    uint16_t channelWidth,
+    MHz_u channelWidth,
     MuType expectedMuType,
     const RuAllocation& expectedRuAllocation,
     const std::pair<std::size_t, std::size_t>& expectedNumUsersPerCc,
@@ -1378,7 +1515,7 @@
     WifiTxVector txVector;
     txVector.SetPreambleType(WIFI_PREAMBLE_HE_MU);
     txVector.SetChannelWidth(m_channelWidth);
-    txVector.SetGuardInterval(3200);
+    txVector.SetGuardInterval(NanoSeconds(3200));
     txVector.SetStbc(false);
     txVector.SetNess(0);
     std::list<uint16_t> staIds;
@@ -1567,7 +1704,7 @@
     {
         phyEntity = Create<OfdmPhy>(variant.first);
         std::size_t ratio = variant.second;
-        uint16_t bw = 20 / ratio; // MHz
+        MHz_u bw = 20 / ratio;
         txVector.SetChannelWidth(bw);
         txVector.SetMode(OfdmPhy::GetOfdmRate(12000000 / ratio, bw));
         nonHtMode = OfdmPhy::GetOfdmRate(6000000 / ratio, bw);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/test/wifi-aggregation-test.cc ns-3.43/src/wifi/test/wifi-aggregation-test.cc
--- ns-3.42/src/wifi/test/wifi-aggregation-test.cc	2024-05-29 15:29:47.216073800 -0700
+++ ns-3.43/src/wifi/test/wifi-aggregation-test.cc	2024-10-09 16:41:10.136656800 -0700
@@ -1,22 +1,12 @@
 /*
  * Copyright (c) 2015
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
 
+#include "ns3/config.h"
 #include "ns3/eht-configuration.h"
 #include "ns3/fcfs-wifi-queue-scheduler.h"
 #include "ns3/he-configuration.h"
@@ -950,11 +940,19 @@
  * maximum A-MPDU size is set to 7500 bytes, hence the remaining packets are sent
  * in an A-MPDU containing two MPDUs, the first one including 4 MSDUs and the second
  * one including 3 MPDUs.
+ *
+ * It is also checked that the MAC header of every MPDU is notified to the FrameExchangeManager
+ * while the PSDU is being transmitted.
  */
 class PreservePacketsInAmpdus : public TestCase
 {
   public:
-    PreservePacketsInAmpdus();
+    /**
+     * Constructor.
+     *
+     * \param notifyMacHdrRxEnd whether notification of MAC header reception end is enabled
+     */
+    PreservePacketsInAmpdus(bool notifyMacHdrRxEnd);
     ~PreservePacketsInAmpdus() override;
 
     void DoRun() override;
@@ -963,6 +961,11 @@
     std::list<Ptr<const Packet>> m_packetList; ///< List of packets passed to the MAC
     std::vector<std::size_t> m_nMpdus;         ///< Number of MPDUs in PSDUs passed to the PHY
     std::vector<std::size_t> m_nMsdus;         ///< Number of MSDUs in MPDUs passed to the PHY
+    Ptr<const WifiPsdu> m_txPsdu;              ///< PSDU being transmitted
+    std::vector<Ptr<WifiMpdu>>::const_iterator
+        m_expectedMpdu;        ///< next MPDU expected to be received
+    std::size_t m_nMacHdrs{0}; ///< Number of notified MAC headers in QoS data frames
+    bool m_notifyMacHdrRxEnd;  ///< whether notification of MAC header reception end is enabled
 
     /**
      * Callback invoked when an MSDU is passed to the MAC
@@ -977,15 +980,27 @@
      */
     void NotifyPsduForwardedDown(WifiConstPsduMap psduMap, WifiTxVector txVector, double txPowerW);
     /**
+     * Callback invoked when the reception of the MAC header of an MPDU is completed.
+     * \param mac the MAC to which the reception of the MAC header is notified
+     * \param macHdr the MAC header of the MPDU being received
+     * \param txVector the TXVECTOR used to transmit the PSDU
+     * \param psduDuration the remaining duration of the PSDU
+     */
+    void NotifyMacHeaderEndRx(Ptr<WifiMac> mac,
+                              const WifiMacHeader& macHdr,
+                              const WifiTxVector& txVector,
+                              Time psduDuration);
+    /**
      * Callback invoked when the receiver MAC forwards a packet up to the upper layer
      * \param p the packet
      */
     void NotifyMacForwardUp(Ptr<const Packet> p);
 };
 
-PreservePacketsInAmpdus::PreservePacketsInAmpdus()
+PreservePacketsInAmpdus::PreservePacketsInAmpdus(bool notifyMacHdrRxEnd)
     : TestCase("Test case to check that the Wifi Mac forwards up the same packets received at "
-               "sender side.")
+               "sender side."),
+      m_notifyMacHdrRxEnd(notifyMacHdrRxEnd)
 {
 }
 
@@ -1008,6 +1023,19 @@
                           true,
                           "No DL MU PPDU expected");
 
+    // m_txPsdu is reset when the MAC header of the last MPDU in the PSDU is notified. By
+    // checking that m_txPsdu is nullptr when starting the transmission of a PSDU, we ensure
+    // that MAC headers are notified to the FEM while receiving MPDUs.
+    if (m_notifyMacHdrRxEnd)
+    {
+        NS_TEST_EXPECT_MSG_EQ(m_txPsdu,
+                              nullptr,
+                              "Missing MAC header notification: m_txPsdu was not reset");
+    }
+
+    m_txPsdu = psduMap.at(SU_STA_ID);
+    m_expectedMpdu = m_txPsdu->begin();
+
     if (!psduMap[SU_STA_ID]->GetHeader(0).IsQosData())
     {
         return;
@@ -1024,6 +1052,46 @@
 }
 
 void
+PreservePacketsInAmpdus::NotifyMacHeaderEndRx(Ptr<WifiMac> mac,
+                                              const WifiMacHeader& macHdr,
+                                              const WifiTxVector& txVector,
+                                              Time psduDuration)
+{
+    NS_TEST_EXPECT_MSG_NE(m_txPsdu,
+                          nullptr,
+                          "Notified of MAC header RX end while no PSDU is being transmitted");
+    // check that the FEM stores the expected MAC header (in a nanosecond, to avoid issues
+    // with the ordering of the callbacks connected to the trace source)
+    auto expectedHdr = (*m_expectedMpdu)->GetHeader();
+    Simulator::Schedule(NanoSeconds(1), [=, this]() {
+        auto macHdr = mac->GetFrameExchangeManager()->GetReceivedMacHdr();
+        NS_TEST_ASSERT_MSG_EQ(macHdr.has_value(),
+                              true,
+                              "Expected the FEM to store the MAC header being received");
+        NS_TEST_EXPECT_MSG_EQ(macHdr->get().GetSequenceNumber(),
+                              expectedHdr.GetSequenceNumber(),
+                              "Wrong sequence number in the MAC header stored by the FEM");
+    });
+
+    if (expectedHdr.IsQosData())
+    {
+        m_nMacHdrs++;
+    }
+
+    if (++m_expectedMpdu == m_txPsdu->end())
+    {
+        m_txPsdu = nullptr;
+        // check that the FEM stores no MAC header right after PSDU end
+        Simulator::Schedule(psduDuration + NanoSeconds(1), [=, this]() {
+            auto macHeader = mac->GetFrameExchangeManager()->GetReceivedMacHdr();
+            NS_TEST_EXPECT_MSG_EQ(macHeader.has_value(),
+                                  false,
+                                  "Expected the FEM to store no MAC header");
+        });
+    }
+}
+
+void
 PreservePacketsInAmpdus::NotifyMacForwardUp(Ptr<const Packet> p)
 {
     auto it = std::find(m_packetList.begin(), m_packetList.end(), p);
@@ -1034,6 +1102,8 @@
 void
 PreservePacketsInAmpdus::DoRun()
 {
+    Config::SetDefault("ns3::WifiPhy::NotifyMacHdrRxEnd", BooleanValue(m_notifyMacHdrRxEnd));
+
     NodeContainer wifiStaNode;
     wifiStaNode.Create(1);
 
@@ -1121,6 +1191,10 @@
     sta_device->GetPhy()->TraceConnectWithoutContext(
         "PhyTxPsduBegin",
         MakeCallback(&PreservePacketsInAmpdus::NotifyPsduForwardedDown, this));
+    ap_device->GetPhy()->TraceConnectWithoutContext(
+        "PhyRxMacHeaderEnd",
+        MakeCallback(&PreservePacketsInAmpdus::NotifyMacHeaderEndRx, this)
+            .Bind(ap_device->GetMac()));
     ap_device->GetMac()->TraceConnectWithoutContext(
         "MacRx",
         MakeCallback(&PreservePacketsInAmpdus::NotifyMacForwardUp, this));
@@ -1140,6 +1214,11 @@
     NS_TEST_EXPECT_MSG_EQ(m_nMpdus[1], 2, "Unexpected number of MPDUs in the second A-MPDU");
     NS_TEST_EXPECT_MSG_EQ(m_nMsdus[1], 4, "Unexpected number of MSDUs in the second MPDU");
     NS_TEST_EXPECT_MSG_EQ(m_nMsdus[2], 3, "Unexpected number of MSDUs in the third MPDU");
+    // Three MPDUs (of type QoS data) have been transmitted, so we expect that 3 MAC headers
+    // have been notified to the FEM
+    NS_TEST_EXPECT_MSG_EQ(m_nMacHdrs,
+                          (m_notifyMacHdrRxEnd ? 3 : 0),
+                          "Unexpected number of MAC headers notified to the FEM");
     // All the packets must have been forwarded up at the receiver
     NS_TEST_EXPECT_MSG_EQ(m_packetList.empty(), true, "Some packets have not been forwarded up");
 }
@@ -1165,7 +1244,8 @@
     AddTestCase(new HeAggregationTest(256), TestCase::Duration::QUICK);
     AddTestCase(new EhtAggregationTest(512), TestCase::Duration::QUICK);
     AddTestCase(new EhtAggregationTest(1024), TestCase::Duration::QUICK);
-    AddTestCase(new PreservePacketsInAmpdus, TestCase::Duration::QUICK);
+    AddTestCase(new PreservePacketsInAmpdus(true), TestCase::Duration::QUICK);
+    AddTestCase(new PreservePacketsInAmpdus(false), TestCase::Duration::QUICK);
 }
 
 static WifiAggregationTestSuite g_wifiAggregationTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/test/wifi-channel-switching-test.cc ns-3.43/src/wifi/test/wifi-channel-switching-test.cc
--- ns-3.42/src/wifi/test/wifi-channel-switching-test.cc	2024-05-29 15:29:47.216073800 -0700
+++ ns-3.43/src/wifi/test/wifi-channel-switching-test.cc	2024-10-09 16:41:10.136656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2021 2020 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -257,7 +246,7 @@
     m_apDevice = wifi.Install(phy, mac, m_apNode);
 
     // Assign fixed streams to random variables in use
-    wifi.AssignStreams(m_apDevice, streamNumber);
+    WifiHelper::AssignStreams(m_apDevice, streamNumber);
 
     MobilityHelper mobility;
     Ptr<ListPositionAllocator> positionAlloc = CreateObject<ListPositionAllocator>();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/test/wifi-dynamic-bw-op-test.cc ns-3.43/src/wifi/test/wifi-dynamic-bw-op-test.cc
--- ns-3.42/src/wifi/test/wifi-dynamic-bw-op-test.cc	2024-05-29 15:29:47.216073800 -0700
+++ ns-3.43/src/wifi/test/wifi-dynamic-bw-op-test.cc	2024-10-09 16:41:10.136656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2022 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -54,9 +43,9 @@
      * Constructor
      *
      * \param channelStr channel setting strings for BSS 0 and BSS 1
-     * \param bss0Width width (MHz) of the transmission in BSS 0 started when BSS 1 is transmitting
+     * \param bss0Width width of the transmission in BSS 0 started when BSS 1 is transmitting
      */
-    WifiUseAvailBwTest(std::initializer_list<std::string> channelStr, uint16_t bss0Width);
+    WifiUseAvailBwTest(std::initializer_list<std::string> channelStr, MHz_u bss0Width);
     ~WifiUseAvailBwTest() override;
 
     /**
@@ -94,7 +83,7 @@
     };
 
     std::vector<std::string> m_channelStr;        ///< channel setting strings
-    uint16_t m_bss0Width;                         ///< width (MHz) of the transmission in BSS 0
+    MHz_u m_bss0Width;                            ///< width of the transmission in BSS 0
                                                   ///< started when BSS 1 is transmitting
     NetDeviceContainer m_staDevices;              ///< container for stations' NetDevices
     NetDeviceContainer m_apDevices;               ///< container for AP's NetDevice
@@ -106,7 +95,7 @@
 };
 
 WifiUseAvailBwTest::WifiUseAvailBwTest(std::initializer_list<std::string> channelStr,
-                                       uint16_t bss0Width)
+                                       MHz_u bss0Width)
     : TestCase("Check transmission on available bandwidth"),
       m_channelStr(channelStr),
       m_bss0Width(bss0Width),
@@ -232,8 +221,8 @@
     Ptr<WifiNetDevice> dev;
 
     // Assign fixed streams to random variables in use
-    streamNumber += wifi.AssignStreams(m_apDevices, streamNumber);
-    streamNumber += wifi.AssignStreams(m_staDevices, streamNumber);
+    streamNumber += WifiHelper::AssignStreams(m_apDevices, streamNumber);
+    streamNumber += WifiHelper::AssignStreams(m_staDevices, streamNumber);
 
     MobilityHelper mobility;
     Ptr<ListPositionAllocator> positionAlloc = CreateObject<ListPositionAllocator>();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/test/wifi-eht-info-elems-test.cc ns-3.43/src/wifi/test/wifi-eht-info-elems-test.cc
--- ns-3.42/src/wifi/test/wifi-eht-info-elems-test.cc	2024-05-29 15:29:47.216073800 -0700
+++ ns-3.43/src/wifi/test/wifi-eht-info-elems-test.cc	2024-10-09 16:41:10.136656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2022 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -779,9 +768,9 @@
     /**
      * Constructor
      * \param is2_4Ghz whether the PHY is operating in 2.4 GHz
-     * \param channelWidth the supported channel width in MHz
+     * \param channelWidth the supported channel width
      */
-    WifiEhtCapabilitiesIeTest(bool is2_4Ghz, uint16_t channelWidth);
+    WifiEhtCapabilitiesIeTest(bool is2_4Ghz, MHz_u channelWidth);
     ~WifiEhtCapabilitiesIeTest() override = default;
 
     /**
@@ -847,11 +836,11 @@
   private:
     void DoRun() override;
 
-    bool m_is2_4Ghz;         //!< whether the PHY is operating in 2.4 GHz
-    uint16_t m_channelWidth; //!< Supported channel width by the PHY (in MHz)
+    bool m_is2_4Ghz;      //!< whether the PHY is operating in 2.4 GHz
+    MHz_u m_channelWidth; //!< Supported channel width by the PHY
 };
 
-WifiEhtCapabilitiesIeTest ::WifiEhtCapabilitiesIeTest(bool is2_4Ghz, uint16_t channelWidth)
+WifiEhtCapabilitiesIeTest ::WifiEhtCapabilitiesIeTest(bool is2_4Ghz, MHz_u channelWidth)
     : HeaderSerializationTestCase{"Check serialization and deserialization of EHT capabilities IE"},
       m_is2_4Ghz{is2_4Ghz},
       m_channelWidth{channelWidth}
@@ -1064,7 +1053,7 @@
 {
     uint8_t maxMcs = 0;
     uint16_t expectedEhtMcsAndNssSetSize = 0;
-    switch (m_channelWidth)
+    switch (static_cast<uint16_t>(m_channelWidth))
     {
     case 20:
         expectedEhtMcsAndNssSetSize = 4;
